<template>
  <div class="solution-wrapper">
    <div class="solution-label">{{ solution.name }}
      <a v-if="hasOneFile(solution?.slug)" target= "_blank" :href="makeOneFileUrl(solution?.slug)">
        <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
        </i>
      </a>
      <template v-if="hasTwoFiles(solution?.slug)">
      <a target= "_blank" :href="makeTwoFilesUrl(solution?.slug)[0]">
        <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
        </i>
      </a>
      <a target= "_blank" :href="makeTwoFilesUrl(solution?.slug)[1]">
        <i class="fa fa-fw fa-info-circle" title="Fiches informatives">
        </i>
      </a>
      </template>
    </div>
    <div class="solution-bar">
      <div
          class="bar-fill"
          :class="'solution-' + solution.id"
          :style="{
            width: `${solutionWidth()}%`
          }"><span class="solution-efficacite"></span></div>
    </div>
  </div>
</template>

<script lang="ts">
import {defineComponent} from 'vue'
import { STATIC_URL } from '../utils/_static';

export default defineComponent({
  name: 'SolutionGraph',
  props: ['solution'],
  setup: (props) => {

    const solutionWidth = () => {
      const e = props.solution.efficacite;
      if (e >= 0 && e <= .25) {
        return 25
      } else if (e >= .25 && e <= .5) {
        return 50
      } else if (e >= .5 && e <= .75) {
        return 75
      } else if (e >= .75 && e <= 1) {
        return 100
      } else {
        return 0
      }
    }

    const hasOneFile = (slug: string): boolean =>
      slug.split('_')[0]
        ? [
            'zone-tampon-humide-artificielle',
            'ripisylve',
            'bande-lignocellulosique-de-saule',
            'b-lignocellulosique-de-saulepeuplier',
            'b-lignocellulosique-de-miscanthus',
            'haie',
            'bande-enherbee',
            'chenal-enherbe'
        ].includes(slug.split('_')[0])
        : false;

    const hasTwoFiles = (slug: string): boolean =>
      slug.split('_')[0]
        ? [
            'ripisylve-bande-enherbee',
            'haie-bande-enherbee'
        ].includes(slug.split('_')[0])
        : false;

    const makeOneFileUrl = (slug: string): string =>
      slug.split('_')[0]
        ?`${STATIC_URL}${slug.split('_')[0]}.pdf`
        : '';

    const makeTwoFilesUrl = (slug: string): string[] => [
        makeOneFileUrl(slug.split('-')[0]),
        makeOneFileUrl('bande-enherbee'),
    ]

    return {
      solution: props.solution,
      solutionWidth,
      makeOneFileUrl,
      makeTwoFilesUrl,
      hasOneFile,
      hasTwoFiles
    }
  }
})
</script>
